@extends('layouts.site.app', ['title' => 'Shopping Cart', 'meta_keyword' => '', 'meta_description' => ''])

@section('content')

<!------- BREADCRUMB --------->
<section class="product-breadcrumb">
    <ul>
        <li><a href="{{ url('/') }}">Home</a></li>
        <li>Shopping Cart</li>
    </ul>
</section>


<!------- CART --------->
<section class="cart-page">
    <h2>My Shopping Cart Items</h2>
    @if( isset($cart_data['item_dtl']) && $cart_data['total_item'] > 0 )

    @foreach (['danger', 'warning', 'success', 'info'] as $msg)
        @if(Session::has('alert-' . $msg))
            <div class="alert-cart-card">
                <h5 class="font-weight-light alert alert-{{ $msg }}">{!! Session::get('alert-' . $msg) !!}</h5>
            </div>
        @endif
    @endforeach

    <div class="cart-body flex">
    	

        <div class="cart-table">
            <div class="cart-table-headings flex"> 
                <p class="c-t-hdng-image">IMAGE</p>
                <p class="c-t-hdng-items">ITEMS</p>
                <!-- <p class="c-t-hdng-pincode">PINCODE</p> -->
                <p class="c-t-hdng-qty">QUANTITY</p>
                <p class="c-t-hdng-price">PRICE</p>
                <p class="c-t-hdng-delivery">DELIVERY</p>
                <p class="c-t-hdng-remove"></p>
            </div> 
            @php
	            $total_shiping_val = 0;  
	            //dd($cart_data['item_dtl']); 
	        @endphp
            <div class="cart-section">
            	@php 
            		$ad = 1;
            		$position = 1;
        		@endphp
            	@foreach( $cart_data['item_dtl'] as $data )
            		
	            	@if($data['order_details_id_giftaddon'] == 0)
	                
	                    <div class="cart-table-details flex">
	                        <div class="cart-prd-img">
	                            @if(isset($data['image']) && $data['image'] != null )
	                                @if(file_exists(public_path('/uploaded/product/'.$data['image'])))
	                                    {!! '<img src="' . URL::to('/') . '/uploaded/product/' . $data['image'] . '" >' !!}
	                                @else
	                                    {!! '<img src="' . URL::to('/').config('global.no_image') . '" >' !!}
	                                @endif
	                            @else
	                                {!! '<img src="'.URL::to('/').config('global.no_image').'" >' !!}
	                            @endif
	                        </div>
	                        <div class="cart-prd-txt flex">
	                            <div class="cart-name-id">
	                                <div class="cart-name">
	                                    <p class="ptitle">
	                                        {{ $data['product_name'] }}
	                                    </p>
	                                </div>
	                                <div class="cart-id-number">
	                                    @if( $data['attribute_name'] != '' )
	                                    	{!! $data['attribute_name'] !!}
	                                    @endif
	                                </div>
	                            </div>
	                            <!-- <div class="cart-pincode">
	                                <p>700011</p>
	                            </div> -->
	                            <div class="cart-quantity-selector" id="fn-sec-{{$position}}">
                                    <button class="main-minus-btn" onclick="changeQty({{ $data['order_detail_id'] }}, {{ $data['product_id'] }}, 'minus', {{ $position }})">-</button>
                                    <span class="main-quantity productQty">{{ $data['qty'] }}</span>
                                    <button class="main-plus-btn" onclick="changeQty({{ $data['order_detail_id'] }}, {{ $data['product_id'] }}, 'plus', {{ $position }})">+</button>
                                </div>
	                            <div class="cart-price">
	                                <p>{!! Currency::default($data['total_price'], ['need_currency' => true, 'number_format' => config('global.number_format_limit')]) !!}</p>
	                            </div>
	                            <div class="cart-delivery">
	                                <p>
	                                	<span>{{ strtoupper($data['shippingmethod_name']) }}</span>
	                                	@if($data['ship_price'] > 0)
	                                		- 
	                                		{!! Currency::default($data['ship_price'], ['need_currency' => true, 'number_format' => config('global.number_format_limit')]) !!}
	                                	@endif
	                            	</p>
	                                <p>On <span>{!! date('D, M d', strtotime($data['delivery_date']))!!}</span></p>
	                                <p>Between <span>{{$data['delivery_time']}}</span></p>
	                                <p>Pincode - <span>{{$data['delivery_pincode']}}</span></p>
	                            </div>
	                            <div class="cart-remove">
	                                <a onclick="return confirm('Are you sure you want to remove the product?')" href="{{ route('remove-item', [base64_encode($data['order_detail_id'])]) }}" class="cart-remove-main"><img src="images/BIN.webp" alt=""></a>
	                            </div>
	                        </div>
	                    </div>
	                	@php $ad = 1; @endphp
	                @else
	                
	                	@if($ad == 1)
	                    <div class="cart-addon-prd-badge">
	                        <p>Addons</p>
	                    </div>
	                    @endif
	                    <div class="cart-table-details cart-addon-product flex">
	                        <div class="cart-prd-img">
	                            @if(isset($data['image']) && $data['image'] != null )
	                                @if(file_exists(public_path('/uploaded/product/'.$data['image'])))
	                                    {!! '<img src="' . URL::to('/') . '/uploaded/product/' . $data['image'] . '" width="50" height="50" border="0">' !!}
	                                @else
	                                    {!! '<img src="' . URL::to('/').config('global.no_image') . '" >' !!}
	                                @endif
	                            @else
	                                {!! '<img src="'.URL::to('/').config('global.no_image').'" >' !!}
	                            @endif
	                        </div>
	                        <div class="cart-prd-txt flex">
	                            <div class="cart-name-id">
	                                <div class="cart-name">
	                                    <p class="ptitle">
	                                        {{ $data['product_name'] }}
	                                    </p>
	                                </div>
	                                <div class="cart-id-number">
	                                </div>
	                            </div>
	                            <!-- <div class="cart-pincode">
	                                <p>700011</p>
	                            </div> -->
	                            <div class="cart-quantity">
	                                <div class="cart-quantity-selector" id="fn-sec-{{$position}}">
	                                    <button class="main-minus-btn" onclick="changeQty({{ $data['order_detail_id'] }}, {{ $data['product_id'] }}, 'minus', {{ $position }})">-</button>
	                                    <span class="main-quantity productQty">{{ $data['qty'] }}</span>
	                                    <button class="main-plus-btn" onclick="changeQty({{ $data['order_detail_id'] }}, {{ $data['product_id'] }}, 'plus', {{ $position }})">+</button>
	                                </div>
	                            </div>
	                            <div class="cart-price">
	                                <p>{!! Currency::default($data['total_price'], ['need_currency' => true, 'number_format' => config('global.number_format_limit')]) !!}</p>
	                            </div>
	                            <div class="cart-delivery"></div>
	                            <div class="cart-remove">
	                                <a onclick="return confirm('Are you sure you want to remove the product?')" href="{{ route('remove-item', [base64_encode($data['order_detail_id'])]) }}" class="cart-remove-addon"><img src="images/cross.webp" alt=""></a>
	                            </div>
	                        </div>
	                    </div>
	                    
	                
	                	@php $ad--; @endphp
	                @endif
	                @php
	                	$position++;
                        $total_shiping_val = $total_shiping_val+$data['ship_price'];
                    @endphp
                @endforeach
            </div>

        </div>
        <div class="cart-right">
            <p class="order-summary">Order Summary</p>
            <div class="coupon">
                <!-- <h3>Have a Coupon Code?</h3> -->
                @php
                	$coupondata = App\Http\Helper::get_coupon_details( $cart_data['order_id'] );
            	@endphp
                <form name="coupon_form" id="coupon_form" method="POST" action="{{ route('coupon') }}" class="flex" novalidate="novalidate">
                	{{ csrf_field() }}
                    <input type="hidden" name="orderid" id="orderid" value="{{ $cart_data['order_id'] }}">
                    
                    <input type="text" name="couponcode" id="couponcode" placeholder="ENTER PROMO CODE" value="{{ @$coupondata->coupon_detail->coupon_code }}" >
                    <button type="submit">APPLY</button>
                </form>
            </div>
            <form name="checkout_form" id="checkout_form" method="POST" action="{{ route('cart-checkout') }}">
                {{ csrf_field() }}
                <div class="pricing">
                    <div class="total-shipping-gst">
                        <div class="total-pricing flex">
                            <p>Sub Total:</p>
                            <p class="t-pr-amount">
                            	@php
			                        $final_price = $cart_price = 0;
			                        echo Currency::default($cart_data['total_cart_price'], ['need_currency' => true, 'number_format' => config('global.number_format_limit')]);
			                        //$final_price = $cart_data['total_cart_price'];
			                    @endphp
                            </p>
                        </div>

                        <?php 
			                $cart_price = $cart_data['total_cart_price'];
			                $discount_amount = 0;
			                if( $coupondata != null ) {
			                    if( $coupondata->applied_for == 'WC' ) {     //If coupon related to whole Cart
			                        if( $coupondata->coupon_detail->type == 'F' ) {
			                            $discount_amount = number_format($coupondata->coupon_detail->amount, 2);
			                        }else {
			                            $discount_amount = number_format((( $cart_data['total_cart_price'] * $coupondata->coupon_detail->amount ) / 100), 2);
			                        }
			                    }
			            ?>

			                <div class="total-pricing flex">
			                    <p>Discount
			                        <a onclick="return confirm('Are you sure you want to remove this coupon?')" 
			                                href="{{ route('remove-applied-coupon', [base64_encode($coupondata->id), base64_encode($coupondata->order_id)]) }}" style="color:red;font-size:20px;font-weight:normal;">
			                            <i class="fa fa-trash"></i>
			                        </a>
			                        <br><span class="cart-discount">
			                        ( {{$coupondata->coupon_detail->coupon_code}} - 
			                            @php
			                                if( $coupondata->coupon_detail->type == 'F' ) {
			                                    echo 'Flat '.Currency::default($coupondata->coupon_detail->amount, ['need_currency' => true, 'number_format' => config('global.number_format_limit') ]).' off';
			                                }else{
			                                    echo $coupondata->coupon_detail->amount.'% off';
			                                }
			                            @endphp )</span>
			                    </p>
			                    <p class="t-pr-amount">
			                        {!! '- '.Currency::default($discount_amount, ['need_currency' => true, 'number_format' => config('global.number_format_limit') ]) !!}
			                    </p>
			                </div>

			            <?php
			                $cart_price = $cart_data['total_cart_price'] - $discount_amount;
			                //echo '</a>';
			                }
			            ?>

                        <div class="shipping-pricing flex">
                            <p>Shipping Charge :</p>
                            <p class="s-pr-amount">
                            	{!! Currency::default($total_shiping_val, ['need_currency' => true, 'number_format' => config('global.number_format_limit')]) !!}
                            </p>
                        </div>
                        <!-- <div class="gst-pricing flex">
                            <p>GST : </p>
                            <p class="s-pr-amount">INCLUSIVE</p>
                        </div> -->
                    </div>
                    <div class="grand-total flex">
                        <p>Order Total [**GST Included]</p>
                        <p class="g-total-price">
                        	<?php 
		                        $grand_total = $total_shiping_val+$cart_price;
		                        echo Currency::default($grand_total, ['need_currency' => true, 'number_format' => config('global.number_format_limit')]);
		                    ?>
                        </p>
                    </div>
                    <div class="cart-price-button">
                        <input type="hidden" name="final_price" id="final_price" value="<?php echo $grand_total;?>" />
                		<input type="hidden" name="order_id" id="order_id" value="<?php echo $cart_data['order_id'];?>" />

                        <button type="submit" class="cart-btn-1">PROCEED TO CHECKOUT</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
    @else
		
    	<div class="no-cart-item">
            <div class="no-cart-item-img">
                <img src="{{ asset('images/no-cart-image.webp') }}" alt="">
            </div>
            <div class="no-cart-item-txt">
                <p>Your Cart Looks Empty</p>
                <p>Looks like you have not added anything to your cart.</p>
                <a href="{{ url('/') }}">Continue Shopping</a>
            </div>
        </div>

    @endif
</section>

<script type="text/javascript">

	function changeQty(oid, pid, operation, position){
        var qty = parseInt($('#fn-sec-'+position).find('.productQty').text());
        console.log(qty);

        if (operation == "plus") {
            qty++;
            //console.log(qty);
            $('#fn-sec-'+position).find('.productQty').text(qty)
        }else{
            
            if (qty > 1) {
                qty--;
            	$('#fn-sec-'+position).find('.productQty').text(qty)
            }
        }

        $.ajaxSetup({
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            }
        });
        $.ajax({
            url: '{{ route("update-item") }}',
            method: 'POST',
            data: {
                qty: qty,
                order_detail_id: oid,
                product_id: pid
            },
            success: function(data){
                //console.log(data);
                if(data.success){
                    location.reload();
                }else if(data.errors){
                    alert("Sorry! Something wrong");
                }
            }
        });
    }

</script>


@endsection